searchNodes=[{"doc":"Defines a behaviour which defines an interface for web servers to flexibly host WebSocket applications. It is commonly used in conjunction with the websock_adapter package which defines concrete adapters on top of Bandit and Cowboy ; the two packages are separate to allow for servers which directly expose WebSock support to depend on just the behaviour. Users will almost always want to depend on websock_adapter instead of this package. WebSocket connections go through a well defined lifecycle mediated by WebSock and WebSock.Adapters : This step is outside the scope of the WebSock API . A client will attempt to Upgrade an HTTP connection to a WebSocket connection by passing a specific set of headers in an HTTP request. An application may choose to determine the feasibility of such an upgrade request however it pleases An application will then signal an upgrade to be performed by calling WebSockAdpater.upgrade/4 , passing in the Plug.Conn to upgrade, along with the WebSock compliant handler module which will handle the connection once it is upgraded The underlying server will then attempt to upgrade the HTTP connection to a WebSocket connection Assuming the WebSocket connection is successfully negotiated, WebSock will call WebSock.init/1 on the configured handler to allow the application to perform any necessary tasks now that the WebSocket connection is live WebSock will call the configued handler's WebSock.handle_in/2 callback whenever data is received from the client WebSock will call the configued handler's WebSock.handle_info/2 callback whenever other processes send messages to the handler process The WebSock implementation can send data to the client by returning a {:push,...} tuple from any of the above handle_* callback At any time, WebSock.terminate/2 may be called to indicate a close, error or timeout condition","ref":"WebSock.html","title":"WebSock","type":"behaviour"},{"doc":"Called by WebSock when a ping or pong frame has been received from the client. Note that implementations SHOULD NOT send a pong frame in response; this MUST be automatically done by the web server before this callback has been called. Despite the name of this callback, it is not called for connection close frames even though they are technically control frames. WebSock will handle any received connection close frames and issue calls to terminate/2 as / if appropriate This callback is optional The return value from this callback is handled as described in handle_in/2","ref":"WebSock.html#c:handle_control/2","title":"WebSock.handle_control/2","type":"callback"},{"doc":"Called by WebSock when a frame is received from the client. WebSock will only call this function once a complete frame has been received (that is, once any continuation frames have been received). The return value from this callback are processed as follows: {:push, {opcode(), message()}, state()} : The indicated message is sent to the client. The indicated state value is used to update the socket's current state {:push, [{opcode(), message()}], state()} : The indicated messages are sent to the client. The indicated state value is used to update the socket's current state {:reply, term(), {opcode(), message()}, state()} : The indicated message is sent to the client. The indicated state value is used to update the socket's current state. The second element of the tuple has no semantic meaning in this context and is ignored. This return tuple is included here solely for backwards compatiblity with the Phoenix.Socket.Transport behaviour; it is in all respects semantically identical to the {:push, ...} return value previously described {:reply, term(), [{opcode(), message()}], state()} : The indicated messages are sent to the client. The indicated state value is used to update the socket's current state. The second element of the tuple has no semantic meaning in this context and is ignored. This return tuple is included here solely for backwards compatiblity with the Phoenix.Socket.Transport behaviour; it is in all respects semantically identical to the {:push, ...} return value previously described {:ok, state()} : The indicated state value is used to update the socket's current state {:stop, reason :: term(), state()} : The connection will be closed based on the indicated reason. If reason is :normal , terminate/2 will be called with a reason value of :normal . In all other cases, it will be called with {:error, reason} . Server implementations should also use this value when determining how to close the connection with the client {:stop, reason :: term(), close_detail(), state()} : Similar to the previous clause, but allows for the explicit setting of either a plain close code or a close code with a body to be sent to the client","ref":"WebSock.html#c:handle_in/2","title":"WebSock.handle_in/2","type":"callback"},{"doc":"Called by WebSock when the socket process receives a GenServer.handle_info/2 call which was not otherwise processed by the server implementation. The return value from this callback is handled as described in handle_in/2","ref":"WebSock.html#c:handle_info/2","title":"WebSock.handle_info/2","type":"callback"},{"doc":"Called by WebSock after a WebSocket connection has been established (that is, after the server has accepted the connection &amp; the WebSocket handshake has been successfully completed). Implementations can use this callback to perform tasks such as subscribing the client to any relevant subscriptions within the application, or any other task which should be undertaken at the time the connection is established The return value from this callback is handled as described in handle_in/2","ref":"WebSock.html#c:init/1","title":"WebSock.init/1","type":"callback"},{"doc":"Called by WebSock when a connection is closed. reason may be one of the following: :normal : The local end shut down the connection normally, by returning a {:stop, :normal, state()} tuple from one of the WebSock.handle_* callbacks :remote : The remote end shut down the connection :shutdown : The local server is being shut down :timeout : No data has been sent or received for more than the configured timeout duration {:error, reason} : An error ocurred. This may be the result of error handling in the local server, or the result of a WebSock.handle_* callback returning a {:stop, reason, state} tuple where reason is any value other than :normal The return value of this callback is ignored","ref":"WebSock.html#c:terminate/2","title":"WebSock.terminate/2","type":"callback"},{"doc":"Describes the data to send in a connection close frame","ref":"WebSock.html#t:close_detail/0","title":"WebSock.close_detail/0","type":"type"},{"doc":"Details about why a connection was closed","ref":"WebSock.html#t:close_reason/0","title":"WebSock.close_reason/0","type":"type"},{"doc":"Possible control frame types","ref":"WebSock.html#t:control_opcode/0","title":"WebSock.control_opcode/0","type":"type"},{"doc":"Possible data frame types","ref":"WebSock.html#t:data_opcode/0","title":"WebSock.data_opcode/0","type":"type"},{"doc":"The result as returned from init, handle_in, handle_control &amp; handle_info calls","ref":"WebSock.html#t:handle_result/0","title":"WebSock.handle_result/0","type":"type"},{"doc":"The type of an implementing module","ref":"WebSock.html#t:impl/0","title":"WebSock.impl/0","type":"type"},{"doc":"The structure of a sent or received WebSocket message body","ref":"WebSock.html#t:message/0","title":"WebSock.message/0","type":"type"},{"doc":"All possible frame types","ref":"WebSock.html#t:opcode/0","title":"WebSock.opcode/0","type":"type"},{"doc":"The type of state passed into / returned from WebSock callbacks","ref":"WebSock.html#t:state/0","title":"WebSock.state/0","type":"type"}]